'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _chalk = require('chalk');

var _chalk2 = _interopRequireWildcard(_chalk);

var _pkg = require('../package.json');

var _pkg2 = _interopRequireWildcard(_pkg);

var isSuppressed = false;

function prepend(str, level) {
    var color = [null, _chalk2['default'].red, _chalk2['default'].yellow, _chalk2['default'].grey][level || 3];
    process.stdout.write(_chalk2['default'].white('[') + color(str || _pkg2['default'].shortname) + _chalk2['default'].white('] '));
}

exports = module.exports = function () {
    if (isSuppressed) {
        return;
    }

    prepend();
    console.log.apply(console, arguments);
};

var error = function error() {
    if (isSuppressed) {
        return;
    }

    prepend(null, 1);
    console.log.apply(console, arguments);
};

exports.error = error;
var suppress = function suppress(flag) {
    isSuppressed = flag;
};
exports.suppress = suppress;